﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
  public interface ILayoutNode<T> where T : class {
    ILayoutNode<T> NextLeft { get; }
    ILayoutNode<T> NextRight { get; }
    ILayoutNode<T> LeftSibling { get; }
    ILayoutNode<T> LeftmostSibling { get; }

    ILayoutNode<T> Thread { get; set; }
    ILayoutNode<T> Ancestor { get; set; }
    ILayoutNode<T> Parent { get; set; }
    List<ILayoutNode<T>> Children { get; set; }

    float Mod { get; set; }
    float Prelim { get; set; }
    float Change { get; set; }
    float Shift { get; set; }
    int Number { get; set; }
    int Level { get; set; }

    float X { get; set; }
    float Y { get; set; }

    bool IsLeaf { get; }

    T Content { get; set; }
  }
}